/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
export * as accessContextManagerAccessLevel from './access-context-manager-access-level';
export * as accessContextManagerAccessLevelCondition from './access-context-manager-access-level-condition';
export * as accessContextManagerAccessLevels from './access-context-manager-access-levels';
export * as accessContextManagerAccessPolicy from './access-context-manager-access-policy';
export * as accessContextManagerAccessPolicyIamBinding from './access-context-manager-access-policy-iam-binding';
export * as accessContextManagerAccessPolicyIamMember from './access-context-manager-access-policy-iam-member';
export * as accessContextManagerAccessPolicyIamPolicy from './access-context-manager-access-policy-iam-policy';
export * as accessContextManagerAuthorizedOrgsDesc from './access-context-manager-authorized-orgs-desc';
export * as accessContextManagerEgressPolicy from './access-context-manager-egress-policy';
export * as accessContextManagerGcpUserAccessBinding from './access-context-manager-gcp-user-access-binding';
export * as accessContextManagerIngressPolicy from './access-context-manager-ingress-policy';
export * as accessContextManagerServicePerimeter from './access-context-manager-service-perimeter';
export * as accessContextManagerServicePerimeterDryRunResource from './access-context-manager-service-perimeter-dry-run-resource';
export * as accessContextManagerServicePerimeterEgressPolicy from './access-context-manager-service-perimeter-egress-policy';
export * as accessContextManagerServicePerimeterIngressPolicy from './access-context-manager-service-perimeter-ingress-policy';
export * as accessContextManagerServicePerimeterResource from './access-context-manager-service-perimeter-resource';
export * as accessContextManagerServicePerimeters from './access-context-manager-service-perimeters';
export * as activeDirectoryDomain from './active-directory-domain';
export * as activeDirectoryDomainTrust from './active-directory-domain-trust';
export * as alloydbBackup from './alloydb-backup';
export * as alloydbCluster from './alloydb-cluster';
export * as alloydbInstance from './alloydb-instance';
export * as alloydbUser from './alloydb-user';
export * as apigeeAddonsConfig from './apigee-addons-config';
export * as apigeeEndpointAttachment from './apigee-endpoint-attachment';
export * as apigeeEnvKeystore from './apigee-env-keystore';
export * as apigeeEnvReferences from './apigee-env-references';
export * as apigeeEnvgroup from './apigee-envgroup';
export * as apigeeEnvgroupAttachment from './apigee-envgroup-attachment';
export * as apigeeEnvironment from './apigee-environment';
export * as apigeeEnvironmentIamBinding from './apigee-environment-iam-binding';
export * as apigeeEnvironmentIamMember from './apigee-environment-iam-member';
export * as apigeeEnvironmentIamPolicy from './apigee-environment-iam-policy';
export * as apigeeFlowhook from './apigee-flowhook';
export * as apigeeInstance from './apigee-instance';
export * as apigeeInstanceAttachment from './apigee-instance-attachment';
export * as apigeeKeystoresAliasesKeyCertFile from './apigee-keystores-aliases-key-cert-file';
export * as apigeeKeystoresAliasesPkcs12 from './apigee-keystores-aliases-pkcs12';
export * as apigeeKeystoresAliasesSelfSignedCert from './apigee-keystores-aliases-self-signed-cert';
export * as apigeeNatAddress from './apigee-nat-address';
export * as apigeeOrganization from './apigee-organization';
export * as apigeeSharedflow from './apigee-sharedflow';
export * as apigeeSharedflowDeployment from './apigee-sharedflow-deployment';
export * as apigeeSyncAuthorization from './apigee-sync-authorization';
export * as apigeeTargetServer from './apigee-target-server';
export * as apikeysKey from './apikeys-key';
export * as appEngineApplication from './app-engine-application';
export * as appEngineApplicationUrlDispatchRules from './app-engine-application-url-dispatch-rules';
export * as appEngineDomainMapping from './app-engine-domain-mapping';
export * as appEngineFirewallRule from './app-engine-firewall-rule';
export * as appEngineFlexibleAppVersion from './app-engine-flexible-app-version';
export * as appEngineServiceNetworkSettings from './app-engine-service-network-settings';
export * as appEngineServiceSplitTraffic from './app-engine-service-split-traffic';
export * as appEngineStandardAppVersion from './app-engine-standard-app-version';
export * as apphubApplication from './apphub-application';
export * as apphubService from './apphub-service';
export * as apphubServiceProjectAttachment from './apphub-service-project-attachment';
export * as apphubWorkload from './apphub-workload';
export * as artifactRegistryRepository from './artifact-registry-repository';
export * as artifactRegistryRepositoryIamBinding from './artifact-registry-repository-iam-binding';
export * as artifactRegistryRepositoryIamMember from './artifact-registry-repository-iam-member';
export * as artifactRegistryRepositoryIamPolicy from './artifact-registry-repository-iam-policy';
export * as assuredWorkloadsWorkload from './assured-workloads-workload';
export * as beyondcorpAppConnection from './beyondcorp-app-connection';
export * as beyondcorpAppConnector from './beyondcorp-app-connector';
export * as beyondcorpAppGateway from './beyondcorp-app-gateway';
export * as biglakeCatalog from './biglake-catalog';
export * as biglakeDatabase from './biglake-database';
export * as biglakeTable from './biglake-table';
export * as bigqueryAnalyticsHubDataExchange from './bigquery-analytics-hub-data-exchange';
export * as bigqueryAnalyticsHubDataExchangeIamBinding from './bigquery-analytics-hub-data-exchange-iam-binding';
export * as bigqueryAnalyticsHubDataExchangeIamMember from './bigquery-analytics-hub-data-exchange-iam-member';
export * as bigqueryAnalyticsHubDataExchangeIamPolicy from './bigquery-analytics-hub-data-exchange-iam-policy';
export * as bigqueryAnalyticsHubListing from './bigquery-analytics-hub-listing';
export * as bigqueryAnalyticsHubListingIamBinding from './bigquery-analytics-hub-listing-iam-binding';
export * as bigqueryAnalyticsHubListingIamMember from './bigquery-analytics-hub-listing-iam-member';
export * as bigqueryAnalyticsHubListingIamPolicy from './bigquery-analytics-hub-listing-iam-policy';
export * as bigqueryBiReservation from './bigquery-bi-reservation';
export * as bigqueryCapacityCommitment from './bigquery-capacity-commitment';
export * as bigqueryConnection from './bigquery-connection';
export * as bigqueryConnectionIamBinding from './bigquery-connection-iam-binding';
export * as bigqueryConnectionIamMember from './bigquery-connection-iam-member';
export * as bigqueryConnectionIamPolicy from './bigquery-connection-iam-policy';
export * as bigqueryDataTransferConfig from './bigquery-data-transfer-config';
export * as bigqueryDatapolicyDataPolicy from './bigquery-datapolicy-data-policy';
export * as bigqueryDatapolicyDataPolicyIamBinding from './bigquery-datapolicy-data-policy-iam-binding';
export * as bigqueryDatapolicyDataPolicyIamMember from './bigquery-datapolicy-data-policy-iam-member';
export * as bigqueryDatapolicyDataPolicyIamPolicy from './bigquery-datapolicy-data-policy-iam-policy';
export * as bigqueryDataset from './bigquery-dataset';
export * as bigqueryDatasetAccess from './bigquery-dataset-access';
export * as bigqueryDatasetIamBinding from './bigquery-dataset-iam-binding';
export * as bigqueryDatasetIamMember from './bigquery-dataset-iam-member';
export * as bigqueryDatasetIamPolicy from './bigquery-dataset-iam-policy';
export * as bigqueryJob from './bigquery-job';
export * as bigqueryReservation from './bigquery-reservation';
export * as bigqueryReservationAssignment from './bigquery-reservation-assignment';
export * as bigqueryRoutine from './bigquery-routine';
export * as bigqueryTable from './bigquery-table';
export * as bigqueryTableIamBinding from './bigquery-table-iam-binding';
export * as bigqueryTableIamMember from './bigquery-table-iam-member';
export * as bigqueryTableIamPolicy from './bigquery-table-iam-policy';
export * as bigtableAppProfile from './bigtable-app-profile';
export * as bigtableAuthorizedView from './bigtable-authorized-view';
export * as bigtableGcPolicy from './bigtable-gc-policy';
export * as bigtableInstance from './bigtable-instance';
export * as bigtableInstanceIamBinding from './bigtable-instance-iam-binding';
export * as bigtableInstanceIamMember from './bigtable-instance-iam-member';
export * as bigtableInstanceIamPolicy from './bigtable-instance-iam-policy';
export * as bigtableTable from './bigtable-table';
export * as bigtableTableIamBinding from './bigtable-table-iam-binding';
export * as bigtableTableIamMember from './bigtable-table-iam-member';
export * as bigtableTableIamPolicy from './bigtable-table-iam-policy';
export * as billingAccountIamBinding from './billing-account-iam-binding';
export * as billingAccountIamMember from './billing-account-iam-member';
export * as billingAccountIamPolicy from './billing-account-iam-policy';
export * as billingBudget from './billing-budget';
export * as billingProjectInfo from './billing-project-info';
export * as billingSubaccount from './billing-subaccount';
export * as binaryAuthorizationAttestor from './binary-authorization-attestor';
export * as binaryAuthorizationAttestorIamBinding from './binary-authorization-attestor-iam-binding';
export * as binaryAuthorizationAttestorIamMember from './binary-authorization-attestor-iam-member';
export * as binaryAuthorizationAttestorIamPolicy from './binary-authorization-attestor-iam-policy';
export * as binaryAuthorizationPolicy from './binary-authorization-policy';
export * as blockchainNodeEngineBlockchainNodes from './blockchain-node-engine-blockchain-nodes';
export * as certificateManagerCertificate from './certificate-manager-certificate';
export * as certificateManagerCertificateIssuanceConfig from './certificate-manager-certificate-issuance-config';
export * as certificateManagerCertificateMap from './certificate-manager-certificate-map';
export * as certificateManagerCertificateMapEntry from './certificate-manager-certificate-map-entry';
export * as certificateManagerDnsAuthorization from './certificate-manager-dns-authorization';
export * as certificateManagerTrustConfig from './certificate-manager-trust-config';
export * as cloudAssetFolderFeed from './cloud-asset-folder-feed';
export * as cloudAssetOrganizationFeed from './cloud-asset-organization-feed';
export * as cloudAssetProjectFeed from './cloud-asset-project-feed';
export * as cloudIdentityGroup from './cloud-identity-group';
export * as cloudIdentityGroupMembership from './cloud-identity-group-membership';
export * as cloudIdsEndpoint from './cloud-ids-endpoint';
export * as cloudQuotasQuotaPreference from './cloud-quotas-quota-preference';
export * as cloudRunDomainMapping from './cloud-run-domain-mapping';
export * as cloudRunService from './cloud-run-service';
export * as cloudRunServiceIamBinding from './cloud-run-service-iam-binding';
export * as cloudRunServiceIamMember from './cloud-run-service-iam-member';
export * as cloudRunServiceIamPolicy from './cloud-run-service-iam-policy';
export * as cloudRunV2Job from './cloud-run-v2-job';
export * as cloudRunV2JobIamBinding from './cloud-run-v2-job-iam-binding';
export * as cloudRunV2JobIamMember from './cloud-run-v2-job-iam-member';
export * as cloudRunV2JobIamPolicy from './cloud-run-v2-job-iam-policy';
export * as cloudRunV2Service from './cloud-run-v2-service';
export * as cloudRunV2ServiceIamBinding from './cloud-run-v2-service-iam-binding';
export * as cloudRunV2ServiceIamMember from './cloud-run-v2-service-iam-member';
export * as cloudRunV2ServiceIamPolicy from './cloud-run-v2-service-iam-policy';
export * as cloudSchedulerJob from './cloud-scheduler-job';
export * as cloudTasksQueue from './cloud-tasks-queue';
export * as cloudTasksQueueIamBinding from './cloud-tasks-queue-iam-binding';
export * as cloudTasksQueueIamMember from './cloud-tasks-queue-iam-member';
export * as cloudTasksQueueIamPolicy from './cloud-tasks-queue-iam-policy';
export * as cloudbuildBitbucketServerConfig from './cloudbuild-bitbucket-server-config';
export * as cloudbuildTrigger from './cloudbuild-trigger';
export * as cloudbuildWorkerPool from './cloudbuild-worker-pool';
export * as cloudbuildv2Connection from './cloudbuildv2-connection';
export * as cloudbuildv2ConnectionIamBinding from './cloudbuildv2-connection-iam-binding';
export * as cloudbuildv2ConnectionIamMember from './cloudbuildv2-connection-iam-member';
export * as cloudbuildv2ConnectionIamPolicy from './cloudbuildv2-connection-iam-policy';
export * as cloudbuildv2Repository from './cloudbuildv2-repository';
export * as clouddeployAutomation from './clouddeploy-automation';
export * as clouddeployCustomTargetType from './clouddeploy-custom-target-type';
export * as clouddeployCustomTargetTypeIamBinding from './clouddeploy-custom-target-type-iam-binding';
export * as clouddeployCustomTargetTypeIamMember from './clouddeploy-custom-target-type-iam-member';
export * as clouddeployCustomTargetTypeIamPolicy from './clouddeploy-custom-target-type-iam-policy';
export * as clouddeployDeliveryPipeline from './clouddeploy-delivery-pipeline';
export * as clouddeployDeliveryPipelineIamBinding from './clouddeploy-delivery-pipeline-iam-binding';
export * as clouddeployDeliveryPipelineIamMember from './clouddeploy-delivery-pipeline-iam-member';
export * as clouddeployDeliveryPipelineIamPolicy from './clouddeploy-delivery-pipeline-iam-policy';
export * as clouddeployTarget from './clouddeploy-target';
export * as clouddeployTargetIamBinding from './clouddeploy-target-iam-binding';
export * as clouddeployTargetIamMember from './clouddeploy-target-iam-member';
export * as clouddeployTargetIamPolicy from './clouddeploy-target-iam-policy';
export * as clouddomainsRegistration from './clouddomains-registration';
export * as cloudfunctions2Function from './cloudfunctions2-function';
export * as cloudfunctions2FunctionIamBinding from './cloudfunctions2-function-iam-binding';
export * as cloudfunctions2FunctionIamMember from './cloudfunctions2-function-iam-member';
export * as cloudfunctions2FunctionIamPolicy from './cloudfunctions2-function-iam-policy';
export * as cloudfunctionsFunction from './cloudfunctions-function';
export * as cloudfunctionsFunctionIamBinding from './cloudfunctions-function-iam-binding';
export * as cloudfunctionsFunctionIamMember from './cloudfunctions-function-iam-member';
export * as cloudfunctionsFunctionIamPolicy from './cloudfunctions-function-iam-policy';
export * as composerEnvironment from './composer-environment';
export * as computeAddress from './compute-address';
export * as computeAttachedDisk from './compute-attached-disk';
export * as computeAutoscaler from './compute-autoscaler';
export * as computeBackendBucket from './compute-backend-bucket';
export * as computeBackendBucketSignedUrlKey from './compute-backend-bucket-signed-url-key';
export * as computeBackendService from './compute-backend-service';
export * as computeBackendServiceSignedUrlKey from './compute-backend-service-signed-url-key';
export * as computeDisk from './compute-disk';
export * as computeDiskAsyncReplication from './compute-disk-async-replication';
export * as computeDiskIamBinding from './compute-disk-iam-binding';
export * as computeDiskIamMember from './compute-disk-iam-member';
export * as computeDiskIamPolicy from './compute-disk-iam-policy';
export * as computeDiskResourcePolicyAttachment from './compute-disk-resource-policy-attachment';
export * as computeExternalVpnGateway from './compute-external-vpn-gateway';
export * as computeFirewall from './compute-firewall';
export * as computeFirewallPolicy from './compute-firewall-policy';
export * as computeFirewallPolicyAssociation from './compute-firewall-policy-association';
export * as computeFirewallPolicyRule from './compute-firewall-policy-rule';
export * as computeForwardingRule from './compute-forwarding-rule';
export * as computeGlobalAddress from './compute-global-address';
export * as computeGlobalForwardingRule from './compute-global-forwarding-rule';
export * as computeGlobalNetworkEndpoint from './compute-global-network-endpoint';
export * as computeGlobalNetworkEndpointGroup from './compute-global-network-endpoint-group';
export * as computeHaVpnGateway from './compute-ha-vpn-gateway';
export * as computeHealthCheck from './compute-health-check';
export * as computeHttpHealthCheck from './compute-http-health-check';
export * as computeHttpsHealthCheck from './compute-https-health-check';
export * as computeImage from './compute-image';
export * as computeImageIamBinding from './compute-image-iam-binding';
export * as computeImageIamMember from './compute-image-iam-member';
export * as computeImageIamPolicy from './compute-image-iam-policy';
export * as computeInstance from './compute-instance';
export * as computeInstanceFromTemplate from './compute-instance-from-template';
export * as computeInstanceGroup from './compute-instance-group';
export * as computeInstanceGroupManager from './compute-instance-group-manager';
export * as computeInstanceGroupMembership from './compute-instance-group-membership';
export * as computeInstanceGroupNamedPort from './compute-instance-group-named-port';
export * as computeInstanceIamBinding from './compute-instance-iam-binding';
export * as computeInstanceIamMember from './compute-instance-iam-member';
export * as computeInstanceIamPolicy from './compute-instance-iam-policy';
export * as computeInstanceSettings from './compute-instance-settings';
export * as computeInstanceTemplate from './compute-instance-template';
export * as computeInterconnect from './compute-interconnect';
export * as computeInterconnectAttachment from './compute-interconnect-attachment';
export * as computeManagedSslCertificate from './compute-managed-ssl-certificate';
export * as computeNetwork from './compute-network';
export * as computeNetworkAttachment from './compute-network-attachment';
export * as computeNetworkEndpoint from './compute-network-endpoint';
export * as computeNetworkEndpointGroup from './compute-network-endpoint-group';
export * as computeNetworkEndpoints from './compute-network-endpoints';
export * as computeNetworkFirewallPolicy from './compute-network-firewall-policy';
export * as computeNetworkFirewallPolicyAssociation from './compute-network-firewall-policy-association';
export * as computeNetworkFirewallPolicyRule from './compute-network-firewall-policy-rule';
export * as computeNetworkPeering from './compute-network-peering';
export * as computeNetworkPeeringRoutesConfig from './compute-network-peering-routes-config';
export * as computeNodeGroup from './compute-node-group';
export * as computeNodeTemplate from './compute-node-template';
export * as computePacketMirroring from './compute-packet-mirroring';
export * as computePerInstanceConfig from './compute-per-instance-config';
export * as computeProjectCloudArmorTier from './compute-project-cloud-armor-tier';
export * as computeProjectDefaultNetworkTier from './compute-project-default-network-tier';
export * as computeProjectMetadata from './compute-project-metadata';
export * as computeProjectMetadataItem from './compute-project-metadata-item';
export * as computePublicAdvertisedPrefix from './compute-public-advertised-prefix';
export * as computePublicDelegatedPrefix from './compute-public-delegated-prefix';
export * as computeRegionAutoscaler from './compute-region-autoscaler';
export * as computeRegionBackendService from './compute-region-backend-service';
export * as computeRegionCommitment from './compute-region-commitment';
export * as computeRegionDisk from './compute-region-disk';
export * as computeRegionDiskIamBinding from './compute-region-disk-iam-binding';
export * as computeRegionDiskIamMember from './compute-region-disk-iam-member';
export * as computeRegionDiskIamPolicy from './compute-region-disk-iam-policy';
export * as computeRegionDiskResourcePolicyAttachment from './compute-region-disk-resource-policy-attachment';
export * as computeRegionHealthCheck from './compute-region-health-check';
export * as computeRegionInstanceGroupManager from './compute-region-instance-group-manager';
export * as computeRegionInstanceTemplate from './compute-region-instance-template';
export * as computeRegionNetworkEndpoint from './compute-region-network-endpoint';
export * as computeRegionNetworkEndpointGroup from './compute-region-network-endpoint-group';
export * as computeRegionNetworkFirewallPolicy from './compute-region-network-firewall-policy';
export * as computeRegionNetworkFirewallPolicyAssociation from './compute-region-network-firewall-policy-association';
export * as computeRegionNetworkFirewallPolicyRule from './compute-region-network-firewall-policy-rule';
export * as computeRegionPerInstanceConfig from './compute-region-per-instance-config';
export * as computeRegionSslCertificate from './compute-region-ssl-certificate';
export * as computeRegionSslPolicy from './compute-region-ssl-policy';
export * as computeRegionTargetHttpProxy from './compute-region-target-http-proxy';
export * as computeRegionTargetHttpsProxy from './compute-region-target-https-proxy';
export * as computeRegionTargetTcpProxy from './compute-region-target-tcp-proxy';
export * as computeRegionUrlMap from './compute-region-url-map';
export * as computeReservation from './compute-reservation';
export * as computeResourcePolicy from './compute-resource-policy';
export * as computeRoute from './compute-route';
export * as computeRouter from './compute-router';
export * as computeRouterInterface from './compute-router-interface';
export * as computeRouterNat from './compute-router-nat';
export * as computeRouterPeer from './compute-router-peer';
export * as computeSecurityPolicy from './compute-security-policy';
export * as computeSecurityPolicyRule from './compute-security-policy-rule';
export * as computeServiceAttachment from './compute-service-attachment';
export * as computeSharedVpcHostProject from './compute-shared-vpc-host-project';
export * as computeSharedVpcServiceProject from './compute-shared-vpc-service-project';
export * as computeSnapshot from './compute-snapshot';
export * as computeSnapshotIamBinding from './compute-snapshot-iam-binding';
export * as computeSnapshotIamMember from './compute-snapshot-iam-member';
export * as computeSnapshotIamPolicy from './compute-snapshot-iam-policy';
export * as computeSslCertificate from './compute-ssl-certificate';
export * as computeSslPolicy from './compute-ssl-policy';
export * as computeSubnetwork from './compute-subnetwork';
export * as computeSubnetworkIamBinding from './compute-subnetwork-iam-binding';
export * as computeSubnetworkIamMember from './compute-subnetwork-iam-member';
export * as computeSubnetworkIamPolicy from './compute-subnetwork-iam-policy';
export * as computeTargetGrpcProxy from './compute-target-grpc-proxy';
export * as computeTargetHttpProxy from './compute-target-http-proxy';
export * as computeTargetHttpsProxy from './compute-target-https-proxy';
export * as computeTargetInstance from './compute-target-instance';
export * as computeTargetPool from './compute-target-pool';
export * as computeTargetSslProxy from './compute-target-ssl-proxy';
export * as computeTargetTcpProxy from './compute-target-tcp-proxy';
export * as computeUrlMap from './compute-url-map';
export * as computeVpnGateway from './compute-vpn-gateway';
export * as computeVpnTunnel from './compute-vpn-tunnel';
export * as containerAnalysisNote from './container-analysis-note';
export * as containerAnalysisNoteIamBinding from './container-analysis-note-iam-binding';
export * as containerAnalysisNoteIamMember from './container-analysis-note-iam-member';
export * as containerAnalysisNoteIamPolicy from './container-analysis-note-iam-policy';
export * as containerAnalysisOccurrence from './container-analysis-occurrence';
export * as containerAttachedCluster from './container-attached-cluster';
export * as containerAwsCluster from './container-aws-cluster';
export * as containerAwsNodePool from './container-aws-node-pool';
export * as containerAzureClient from './container-azure-client';
export * as containerAzureCluster from './container-azure-cluster';
export * as containerAzureNodePool from './container-azure-node-pool';
export * as containerCluster from './container-cluster';
export * as containerNodePool from './container-node-pool';
export * as containerRegistry from './container-registry';
export * as dataCatalogEntry from './data-catalog-entry';
export * as dataCatalogEntryGroup from './data-catalog-entry-group';
export * as dataCatalogEntryGroupIamBinding from './data-catalog-entry-group-iam-binding';
export * as dataCatalogEntryGroupIamMember from './data-catalog-entry-group-iam-member';
export * as dataCatalogEntryGroupIamPolicy from './data-catalog-entry-group-iam-policy';
export * as dataCatalogPolicyTag from './data-catalog-policy-tag';
export * as dataCatalogPolicyTagIamBinding from './data-catalog-policy-tag-iam-binding';
export * as dataCatalogPolicyTagIamMember from './data-catalog-policy-tag-iam-member';
export * as dataCatalogPolicyTagIamPolicy from './data-catalog-policy-tag-iam-policy';
export * as dataCatalogTag from './data-catalog-tag';
export * as dataCatalogTagTemplate from './data-catalog-tag-template';
export * as dataCatalogTagTemplateIamBinding from './data-catalog-tag-template-iam-binding';
export * as dataCatalogTagTemplateIamMember from './data-catalog-tag-template-iam-member';
export * as dataCatalogTagTemplateIamPolicy from './data-catalog-tag-template-iam-policy';
export * as dataCatalogTaxonomy from './data-catalog-taxonomy';
export * as dataCatalogTaxonomyIamBinding from './data-catalog-taxonomy-iam-binding';
export * as dataCatalogTaxonomyIamMember from './data-catalog-taxonomy-iam-member';
export * as dataCatalogTaxonomyIamPolicy from './data-catalog-taxonomy-iam-policy';
export * as dataFusionInstance from './data-fusion-instance';
export * as dataFusionInstanceIamBinding from './data-fusion-instance-iam-binding';
export * as dataFusionInstanceIamMember from './data-fusion-instance-iam-member';
export * as dataFusionInstanceIamPolicy from './data-fusion-instance-iam-policy';
export * as dataLossPreventionDeidentifyTemplate from './data-loss-prevention-deidentify-template';
export * as dataLossPreventionDiscoveryConfig from './data-loss-prevention-discovery-config';
export * as dataLossPreventionInspectTemplate from './data-loss-prevention-inspect-template';
export * as dataLossPreventionJobTrigger from './data-loss-prevention-job-trigger';
export * as dataLossPreventionStoredInfoType from './data-loss-prevention-stored-info-type';
export * as dataPipelinePipeline from './data-pipeline-pipeline';
export * as databaseMigrationServiceConnectionProfile from './database-migration-service-connection-profile';
export * as databaseMigrationServicePrivateConnection from './database-migration-service-private-connection';
export * as dataflowJob from './dataflow-job';
export * as dataplexAspectType from './dataplex-aspect-type';
export * as dataplexAspectTypeIamBinding from './dataplex-aspect-type-iam-binding';
export * as dataplexAspectTypeIamMember from './dataplex-aspect-type-iam-member';
export * as dataplexAspectTypeIamPolicy from './dataplex-aspect-type-iam-policy';
export * as dataplexAsset from './dataplex-asset';
export * as dataplexAssetIamBinding from './dataplex-asset-iam-binding';
export * as dataplexAssetIamMember from './dataplex-asset-iam-member';
export * as dataplexAssetIamPolicy from './dataplex-asset-iam-policy';
export * as dataplexDatascan from './dataplex-datascan';
export * as dataplexDatascanIamBinding from './dataplex-datascan-iam-binding';
export * as dataplexDatascanIamMember from './dataplex-datascan-iam-member';
export * as dataplexDatascanIamPolicy from './dataplex-datascan-iam-policy';
export * as dataplexEntryGroup from './dataplex-entry-group';
export * as dataplexEntryGroupIamBinding from './dataplex-entry-group-iam-binding';
export * as dataplexEntryGroupIamMember from './dataplex-entry-group-iam-member';
export * as dataplexEntryGroupIamPolicy from './dataplex-entry-group-iam-policy';
export * as dataplexEntryType from './dataplex-entry-type';
export * as dataplexEntryTypeIamBinding from './dataplex-entry-type-iam-binding';
export * as dataplexEntryTypeIamMember from './dataplex-entry-type-iam-member';
export * as dataplexEntryTypeIamPolicy from './dataplex-entry-type-iam-policy';
export * as dataplexLake from './dataplex-lake';
export * as dataplexLakeIamBinding from './dataplex-lake-iam-binding';
export * as dataplexLakeIamMember from './dataplex-lake-iam-member';
export * as dataplexLakeIamPolicy from './dataplex-lake-iam-policy';
export * as dataplexTask from './dataplex-task';
export * as dataplexTaskIamBinding from './dataplex-task-iam-binding';
export * as dataplexTaskIamMember from './dataplex-task-iam-member';
export * as dataplexTaskIamPolicy from './dataplex-task-iam-policy';
export * as dataplexZone from './dataplex-zone';
export * as dataplexZoneIamBinding from './dataplex-zone-iam-binding';
export * as dataplexZoneIamMember from './dataplex-zone-iam-member';
export * as dataplexZoneIamPolicy from './dataplex-zone-iam-policy';
export * as dataprocAutoscalingPolicy from './dataproc-autoscaling-policy';
export * as dataprocAutoscalingPolicyIamBinding from './dataproc-autoscaling-policy-iam-binding';
export * as dataprocAutoscalingPolicyIamMember from './dataproc-autoscaling-policy-iam-member';
export * as dataprocAutoscalingPolicyIamPolicy from './dataproc-autoscaling-policy-iam-policy';
export * as dataprocCluster from './dataproc-cluster';
export * as dataprocClusterIamBinding from './dataproc-cluster-iam-binding';
export * as dataprocClusterIamMember from './dataproc-cluster-iam-member';
export * as dataprocClusterIamPolicy from './dataproc-cluster-iam-policy';
export * as dataprocJob from './dataproc-job';
export * as dataprocJobIamBinding from './dataproc-job-iam-binding';
export * as dataprocJobIamMember from './dataproc-job-iam-member';
export * as dataprocJobIamPolicy from './dataproc-job-iam-policy';
export * as dataprocMetastoreFederation from './dataproc-metastore-federation';
export * as dataprocMetastoreFederationIamBinding from './dataproc-metastore-federation-iam-binding';
export * as dataprocMetastoreFederationIamMember from './dataproc-metastore-federation-iam-member';
export * as dataprocMetastoreFederationIamPolicy from './dataproc-metastore-federation-iam-policy';
export * as dataprocMetastoreService from './dataproc-metastore-service';
export * as dataprocMetastoreServiceIamBinding from './dataproc-metastore-service-iam-binding';
export * as dataprocMetastoreServiceIamMember from './dataproc-metastore-service-iam-member';
export * as dataprocMetastoreServiceIamPolicy from './dataproc-metastore-service-iam-policy';
export * as dataprocWorkflowTemplate from './dataproc-workflow-template';
export * as datastoreIndex from './datastore-index';
export * as datastreamConnectionProfile from './datastream-connection-profile';
export * as datastreamPrivateConnection from './datastream-private-connection';
export * as datastreamStream from './datastream-stream';
export * as deploymentManagerDeployment from './deployment-manager-deployment';
export * as dialogflowAgent from './dialogflow-agent';
export * as dialogflowCxAgent from './dialogflow-cx-agent';
export * as dialogflowCxEntityType from './dialogflow-cx-entity-type';
export * as dialogflowCxEnvironment from './dialogflow-cx-environment';
export * as dialogflowCxFlow from './dialogflow-cx-flow';
export * as dialogflowCxIntent from './dialogflow-cx-intent';
export * as dialogflowCxPage from './dialogflow-cx-page';
export * as dialogflowCxSecuritySettings from './dialogflow-cx-security-settings';
export * as dialogflowCxTestCase from './dialogflow-cx-test-case';
export * as dialogflowCxVersion from './dialogflow-cx-version';
export * as dialogflowCxWebhook from './dialogflow-cx-webhook';
export * as dialogflowEntityType from './dialogflow-entity-type';
export * as dialogflowFulfillment from './dialogflow-fulfillment';
export * as dialogflowIntent from './dialogflow-intent';
export * as discoveryEngineChatEngine from './discovery-engine-chat-engine';
export * as discoveryEngineDataStore from './discovery-engine-data-store';
export * as discoveryEngineSearchEngine from './discovery-engine-search-engine';
export * as dnsManagedZone from './dns-managed-zone';
export * as dnsManagedZoneIamBinding from './dns-managed-zone-iam-binding';
export * as dnsManagedZoneIamMember from './dns-managed-zone-iam-member';
export * as dnsManagedZoneIamPolicy from './dns-managed-zone-iam-policy';
export * as dnsPolicy from './dns-policy';
export * as dnsRecordSet from './dns-record-set';
export * as dnsResponsePolicy from './dns-response-policy';
export * as dnsResponsePolicyRule from './dns-response-policy-rule';
export * as documentAiProcessor from './document-ai-processor';
export * as documentAiProcessorDefaultVersion from './document-ai-processor-default-version';
export * as documentAiWarehouseDocumentSchema from './document-ai-warehouse-document-schema';
export * as documentAiWarehouseLocation from './document-ai-warehouse-location';
export * as edgecontainerCluster from './edgecontainer-cluster';
export * as edgecontainerNodePool from './edgecontainer-node-pool';
export * as edgecontainerVpnConnection from './edgecontainer-vpn-connection';
export * as edgenetworkNetwork from './edgenetwork-network';
export * as edgenetworkSubnet from './edgenetwork-subnet';
export * as endpointsService from './endpoints-service';
export * as endpointsServiceConsumersIamBinding from './endpoints-service-consumers-iam-binding';
export * as endpointsServiceConsumersIamMember from './endpoints-service-consumers-iam-member';
export * as endpointsServiceConsumersIamPolicy from './endpoints-service-consumers-iam-policy';
export * as endpointsServiceIamBinding from './endpoints-service-iam-binding';
export * as endpointsServiceIamMember from './endpoints-service-iam-member';
export * as endpointsServiceIamPolicy from './endpoints-service-iam-policy';
export * as essentialContactsContact from './essential-contacts-contact';
export * as eventarcChannel from './eventarc-channel';
export * as eventarcGoogleChannelConfig from './eventarc-google-channel-config';
export * as eventarcTrigger from './eventarc-trigger';
export * as filestoreBackup from './filestore-backup';
export * as filestoreInstance from './filestore-instance';
export * as filestoreSnapshot from './filestore-snapshot';
export * as firebaseAppCheckAppAttestConfig from './firebase-app-check-app-attest-config';
export * as firebaseAppCheckDebugToken from './firebase-app-check-debug-token';
export * as firebaseAppCheckDeviceCheckConfig from './firebase-app-check-device-check-config';
export * as firebaseAppCheckPlayIntegrityConfig from './firebase-app-check-play-integrity-config';
export * as firebaseAppCheckRecaptchaEnterpriseConfig from './firebase-app-check-recaptcha-enterprise-config';
export * as firebaseAppCheckRecaptchaV3Config from './firebase-app-check-recaptcha-v3-config';
export * as firebaseAppCheckServiceConfig from './firebase-app-check-service-config';
export * as firebaserulesRelease from './firebaserules-release';
export * as firebaserulesRuleset from './firebaserules-ruleset';
export * as firestoreBackupSchedule from './firestore-backup-schedule';
export * as firestoreDatabase from './firestore-database';
export * as firestoreDocument from './firestore-document';
export * as firestoreField from './firestore-field';
export * as firestoreIndex from './firestore-index';
export * as folder from './folder';
export * as folderAccessApprovalSettings from './folder-access-approval-settings';
export * as folderIamAuditConfig from './folder-iam-audit-config';
export * as folderIamBinding from './folder-iam-binding';
export * as folderIamMember from './folder-iam-member';
export * as folderIamPolicy from './folder-iam-policy';
export * as folderOrganizationPolicy from './folder-organization-policy';
export * as gkeBackupBackupPlan from './gke-backup-backup-plan';
export * as gkeBackupBackupPlanIamBinding from './gke-backup-backup-plan-iam-binding';
export * as gkeBackupBackupPlanIamMember from './gke-backup-backup-plan-iam-member';
export * as gkeBackupBackupPlanIamPolicy from './gke-backup-backup-plan-iam-policy';
export * as gkeBackupRestorePlan from './gke-backup-restore-plan';
export * as gkeBackupRestorePlanIamBinding from './gke-backup-restore-plan-iam-binding';
export * as gkeBackupRestorePlanIamMember from './gke-backup-restore-plan-iam-member';
export * as gkeBackupRestorePlanIamPolicy from './gke-backup-restore-plan-iam-policy';
export * as gkeHubFeature from './gke-hub-feature';
export * as gkeHubFeatureIamBinding from './gke-hub-feature-iam-binding';
export * as gkeHubFeatureIamMember from './gke-hub-feature-iam-member';
export * as gkeHubFeatureIamPolicy from './gke-hub-feature-iam-policy';
export * as gkeHubFeatureMembership from './gke-hub-feature-membership';
export * as gkeHubFleet from './gke-hub-fleet';
export * as gkeHubMembership from './gke-hub-membership';
export * as gkeHubMembershipBinding from './gke-hub-membership-binding';
export * as gkeHubMembershipIamBinding from './gke-hub-membership-iam-binding';
export * as gkeHubMembershipIamMember from './gke-hub-membership-iam-member';
export * as gkeHubMembershipIamPolicy from './gke-hub-membership-iam-policy';
export * as gkeHubNamespace from './gke-hub-namespace';
export * as gkeHubScope from './gke-hub-scope';
export * as gkeHubScopeIamBinding from './gke-hub-scope-iam-binding';
export * as gkeHubScopeIamMember from './gke-hub-scope-iam-member';
export * as gkeHubScopeIamPolicy from './gke-hub-scope-iam-policy';
export * as gkeHubScopeRbacRoleBinding from './gke-hub-scope-rbac-role-binding';
export * as gkeonpremBareMetalAdminCluster from './gkeonprem-bare-metal-admin-cluster';
export * as gkeonpremBareMetalCluster from './gkeonprem-bare-metal-cluster';
export * as gkeonpremBareMetalNodePool from './gkeonprem-bare-metal-node-pool';
export * as gkeonpremVmwareCluster from './gkeonprem-vmware-cluster';
export * as gkeonpremVmwareNodePool from './gkeonprem-vmware-node-pool';
export * as healthcareConsentStore from './healthcare-consent-store';
export * as healthcareConsentStoreIamBinding from './healthcare-consent-store-iam-binding';
export * as healthcareConsentStoreIamMember from './healthcare-consent-store-iam-member';
export * as healthcareConsentStoreIamPolicy from './healthcare-consent-store-iam-policy';
export * as healthcareDataset from './healthcare-dataset';
export * as healthcareDatasetIamBinding from './healthcare-dataset-iam-binding';
export * as healthcareDatasetIamMember from './healthcare-dataset-iam-member';
export * as healthcareDatasetIamPolicy from './healthcare-dataset-iam-policy';
export * as healthcareDicomStore from './healthcare-dicom-store';
export * as healthcareDicomStoreIamBinding from './healthcare-dicom-store-iam-binding';
export * as healthcareDicomStoreIamMember from './healthcare-dicom-store-iam-member';
export * as healthcareDicomStoreIamPolicy from './healthcare-dicom-store-iam-policy';
export * as healthcareFhirStore from './healthcare-fhir-store';
export * as healthcareFhirStoreIamBinding from './healthcare-fhir-store-iam-binding';
export * as healthcareFhirStoreIamMember from './healthcare-fhir-store-iam-member';
export * as healthcareFhirStoreIamPolicy from './healthcare-fhir-store-iam-policy';
export * as healthcareHl7V2Store from './healthcare-hl7-v2-store';
export * as healthcareHl7V2StoreIamBinding from './healthcare-hl7-v2-store-iam-binding';
export * as healthcareHl7V2StoreIamMember from './healthcare-hl7-v2-store-iam-member';
export * as healthcareHl7V2StoreIamPolicy from './healthcare-hl7-v2-store-iam-policy';
export * as iamAccessBoundaryPolicy from './iam-access-boundary-policy';
export * as iamDenyPolicy from './iam-deny-policy';
export * as iamWorkforcePool from './iam-workforce-pool';
export * as iamWorkforcePoolProvider from './iam-workforce-pool-provider';
export * as iamWorkloadIdentityPool from './iam-workload-identity-pool';
export * as iamWorkloadIdentityPoolProvider from './iam-workload-identity-pool-provider';
export * as iapAppEngineServiceIamBinding from './iap-app-engine-service-iam-binding';
export * as iapAppEngineServiceIamMember from './iap-app-engine-service-iam-member';
export * as iapAppEngineServiceIamPolicy from './iap-app-engine-service-iam-policy';
export * as iapAppEngineVersionIamBinding from './iap-app-engine-version-iam-binding';
export * as iapAppEngineVersionIamMember from './iap-app-engine-version-iam-member';
export * as iapAppEngineVersionIamPolicy from './iap-app-engine-version-iam-policy';
export * as iapBrand from './iap-brand';
export * as iapClient from './iap-client';
export * as iapTunnelDestGroup from './iap-tunnel-dest-group';
export * as iapTunnelDestGroupIamBinding from './iap-tunnel-dest-group-iam-binding';
export * as iapTunnelDestGroupIamMember from './iap-tunnel-dest-group-iam-member';
export * as iapTunnelDestGroupIamPolicy from './iap-tunnel-dest-group-iam-policy';
export * as iapTunnelIamBinding from './iap-tunnel-iam-binding';
export * as iapTunnelIamMember from './iap-tunnel-iam-member';
export * as iapTunnelIamPolicy from './iap-tunnel-iam-policy';
export * as iapTunnelInstanceIamBinding from './iap-tunnel-instance-iam-binding';
export * as iapTunnelInstanceIamMember from './iap-tunnel-instance-iam-member';
export * as iapTunnelInstanceIamPolicy from './iap-tunnel-instance-iam-policy';
export * as iapWebBackendServiceIamBinding from './iap-web-backend-service-iam-binding';
export * as iapWebBackendServiceIamMember from './iap-web-backend-service-iam-member';
export * as iapWebBackendServiceIamPolicy from './iap-web-backend-service-iam-policy';
export * as iapWebIamBinding from './iap-web-iam-binding';
export * as iapWebIamMember from './iap-web-iam-member';
export * as iapWebIamPolicy from './iap-web-iam-policy';
export * as iapWebRegionBackendServiceIamBinding from './iap-web-region-backend-service-iam-binding';
export * as iapWebRegionBackendServiceIamMember from './iap-web-region-backend-service-iam-member';
export * as iapWebRegionBackendServiceIamPolicy from './iap-web-region-backend-service-iam-policy';
export * as iapWebTypeAppEngineIamBinding from './iap-web-type-app-engine-iam-binding';
export * as iapWebTypeAppEngineIamMember from './iap-web-type-app-engine-iam-member';
export * as iapWebTypeAppEngineIamPolicy from './iap-web-type-app-engine-iam-policy';
export * as iapWebTypeComputeIamBinding from './iap-web-type-compute-iam-binding';
export * as iapWebTypeComputeIamMember from './iap-web-type-compute-iam-member';
export * as iapWebTypeComputeIamPolicy from './iap-web-type-compute-iam-policy';
export * as identityPlatformConfig from './identity-platform-config';
export * as identityPlatformDefaultSupportedIdpConfig from './identity-platform-default-supported-idp-config';
export * as identityPlatformInboundSamlConfig from './identity-platform-inbound-saml-config';
export * as identityPlatformOauthIdpConfig from './identity-platform-oauth-idp-config';
export * as identityPlatformProjectDefaultConfig from './identity-platform-project-default-config';
export * as identityPlatformTenant from './identity-platform-tenant';
export * as identityPlatformTenantDefaultSupportedIdpConfig from './identity-platform-tenant-default-supported-idp-config';
export * as identityPlatformTenantInboundSamlConfig from './identity-platform-tenant-inbound-saml-config';
export * as identityPlatformTenantOauthIdpConfig from './identity-platform-tenant-oauth-idp-config';
export * as integrationConnectorsConnection from './integration-connectors-connection';
export * as integrationConnectorsEndpointAttachment from './integration-connectors-endpoint-attachment';
export * as integrationConnectorsManagedZone from './integration-connectors-managed-zone';
export * as integrationsAuthConfig from './integrations-auth-config';
export * as integrationsClient from './integrations-client';
export * as kmsCryptoKey from './kms-crypto-key';
export * as kmsCryptoKeyIamBinding from './kms-crypto-key-iam-binding';
export * as kmsCryptoKeyIamMember from './kms-crypto-key-iam-member';
export * as kmsCryptoKeyIamPolicy from './kms-crypto-key-iam-policy';
export * as kmsCryptoKeyVersion from './kms-crypto-key-version';
export * as kmsEkmConnection from './kms-ekm-connection';
export * as kmsKeyRing from './kms-key-ring';
export * as kmsKeyRingIamBinding from './kms-key-ring-iam-binding';
export * as kmsKeyRingIamMember from './kms-key-ring-iam-member';
export * as kmsKeyRingIamPolicy from './kms-key-ring-iam-policy';
export * as kmsKeyRingImportJob from './kms-key-ring-import-job';
export * as kmsSecretCiphertext from './kms-secret-ciphertext';
export * as loggingBillingAccountBucketConfig from './logging-billing-account-bucket-config';
export * as loggingBillingAccountExclusion from './logging-billing-account-exclusion';
export * as loggingBillingAccountSink from './logging-billing-account-sink';
export * as loggingFolderBucketConfig from './logging-folder-bucket-config';
export * as loggingFolderExclusion from './logging-folder-exclusion';
export * as loggingFolderSettings from './logging-folder-settings';
export * as loggingFolderSink from './logging-folder-sink';
export * as loggingLinkedDataset from './logging-linked-dataset';
export * as loggingLogView from './logging-log-view';
export * as loggingMetric from './logging-metric';
export * as loggingOrganizationBucketConfig from './logging-organization-bucket-config';
export * as loggingOrganizationExclusion from './logging-organization-exclusion';
export * as loggingOrganizationSettings from './logging-organization-settings';
export * as loggingOrganizationSink from './logging-organization-sink';
export * as loggingProjectBucketConfig from './logging-project-bucket-config';
export * as loggingProjectExclusion from './logging-project-exclusion';
export * as loggingProjectSink from './logging-project-sink';
export * as lookerInstance from './looker-instance';
export * as memcacheInstance from './memcache-instance';
export * as migrationCenterGroup from './migration-center-group';
export * as migrationCenterPreferenceSet from './migration-center-preference-set';
export * as mlEngineModel from './ml-engine-model';
export * as monitoringAlertPolicy from './monitoring-alert-policy';
export * as monitoringCustomService from './monitoring-custom-service';
export * as monitoringDashboard from './monitoring-dashboard';
export * as monitoringGroup from './monitoring-group';
export * as monitoringMetricDescriptor from './monitoring-metric-descriptor';
export * as monitoringMonitoredProject from './monitoring-monitored-project';
export * as monitoringNotificationChannel from './monitoring-notification-channel';
export * as monitoringService from './monitoring-service';
export * as monitoringSlo from './monitoring-slo';
export * as monitoringUptimeCheckConfig from './monitoring-uptime-check-config';
export * as netappActiveDirectory from './netapp-active-directory';
export * as netappBackup from './netapp-backup';
export * as netappBackupPolicy from './netapp-backup-policy';
export * as netappBackupVault from './netapp-backup-vault';
export * as netappKmsconfig from './netapp-kmsconfig';
export * as netappStoragePool from './netapp-storage-pool';
export * as netappVolume from './netapp-volume';
export * as netappVolumeReplication from './netapp-volume-replication';
export * as netappVolumeSnapshot from './netapp-volume-snapshot';
export * as networkConnectivityHub from './network-connectivity-hub';
export * as networkConnectivityInternalRange from './network-connectivity-internal-range';
export * as networkConnectivityPolicyBasedRoute from './network-connectivity-policy-based-route';
export * as networkConnectivityRegionalEndpoint from './network-connectivity-regional-endpoint';
export * as networkConnectivityServiceConnectionPolicy from './network-connectivity-service-connection-policy';
export * as networkConnectivitySpoke from './network-connectivity-spoke';
export * as networkManagementConnectivityTest from './network-management-connectivity-test';
export * as networkSecurityAddressGroup from './network-security-address-group';
export * as networkSecurityAddressGroupIamBinding from './network-security-address-group-iam-binding';
export * as networkSecurityAddressGroupIamMember from './network-security-address-group-iam-member';
export * as networkSecurityAddressGroupIamPolicy from './network-security-address-group-iam-policy';
export * as networkSecurityFirewallEndpoint from './network-security-firewall-endpoint';
export * as networkSecurityFirewallEndpointAssociation from './network-security-firewall-endpoint-association';
export * as networkSecurityGatewaySecurityPolicy from './network-security-gateway-security-policy';
export * as networkSecurityGatewaySecurityPolicyRule from './network-security-gateway-security-policy-rule';
export * as networkSecuritySecurityProfile from './network-security-security-profile';
export * as networkSecuritySecurityProfileGroup from './network-security-security-profile-group';
export * as networkSecurityTlsInspectionPolicy from './network-security-tls-inspection-policy';
export * as networkSecurityUrlLists from './network-security-url-lists';
export * as networkServicesEdgeCacheKeyset from './network-services-edge-cache-keyset';
export * as networkServicesEdgeCacheOrigin from './network-services-edge-cache-origin';
export * as networkServicesEdgeCacheService from './network-services-edge-cache-service';
export * as networkServicesGateway from './network-services-gateway';
export * as networkServicesLbRouteExtension from './network-services-lb-route-extension';
export * as networkServicesLbTrafficExtension from './network-services-lb-traffic-extension';
export * as notebooksEnvironment from './notebooks-environment';
export * as notebooksInstance from './notebooks-instance';
export * as notebooksInstanceIamBinding from './notebooks-instance-iam-binding';
export * as notebooksInstanceIamMember from './notebooks-instance-iam-member';
export * as notebooksInstanceIamPolicy from './notebooks-instance-iam-policy';
export * as notebooksLocation from './notebooks-location';
export * as notebooksRuntime from './notebooks-runtime';
export * as notebooksRuntimeIamBinding from './notebooks-runtime-iam-binding';
export * as notebooksRuntimeIamMember from './notebooks-runtime-iam-member';
export * as notebooksRuntimeIamPolicy from './notebooks-runtime-iam-policy';
export * as orgPolicyCustomConstraint from './org-policy-custom-constraint';
export * as orgPolicyPolicy from './org-policy-policy';
export * as organizationAccessApprovalSettings from './organization-access-approval-settings';
export * as organizationIamAuditConfig from './organization-iam-audit-config';
export * as organizationIamBinding from './organization-iam-binding';
export * as organizationIamCustomRole from './organization-iam-custom-role';
export * as organizationIamMember from './organization-iam-member';
export * as organizationIamPolicy from './organization-iam-policy';
export * as organizationPolicy from './organization-policy';
export * as osConfigOsPolicyAssignment from './os-config-os-policy-assignment';
export * as osConfigPatchDeployment from './os-config-patch-deployment';
export * as osLoginSshPublicKey from './os-login-ssh-public-key';
export * as privatecaCaPool from './privateca-ca-pool';
export * as privatecaCaPoolIamBinding from './privateca-ca-pool-iam-binding';
export * as privatecaCaPoolIamMember from './privateca-ca-pool-iam-member';
export * as privatecaCaPoolIamPolicy from './privateca-ca-pool-iam-policy';
export * as privatecaCertificate from './privateca-certificate';
export * as privatecaCertificateAuthority from './privateca-certificate-authority';
export * as privatecaCertificateTemplate from './privateca-certificate-template';
export * as privatecaCertificateTemplateIamBinding from './privateca-certificate-template-iam-binding';
export * as privatecaCertificateTemplateIamMember from './privateca-certificate-template-iam-member';
export * as privatecaCertificateTemplateIamPolicy from './privateca-certificate-template-iam-policy';
export * as project from './project';
export * as projectAccessApprovalSettings from './project-access-approval-settings';
export * as projectDefaultServiceAccounts from './project-default-service-accounts';
export * as projectIamAuditConfig from './project-iam-audit-config';
export * as projectIamBinding from './project-iam-binding';
export * as projectIamCustomRole from './project-iam-custom-role';
export * as projectIamMember from './project-iam-member';
export * as projectIamMemberRemove from './project-iam-member-remove';
export * as projectIamPolicy from './project-iam-policy';
export * as projectOrganizationPolicy from './project-organization-policy';
export * as projectService from './project-service';
export * as projectUsageExportBucket from './project-usage-export-bucket';
export * as publicCaExternalAccountKey from './public-ca-external-account-key';
export * as pubsubLiteReservation from './pubsub-lite-reservation';
export * as pubsubLiteSubscription from './pubsub-lite-subscription';
export * as pubsubLiteTopic from './pubsub-lite-topic';
export * as pubsubSchema from './pubsub-schema';
export * as pubsubSchemaIamBinding from './pubsub-schema-iam-binding';
export * as pubsubSchemaIamMember from './pubsub-schema-iam-member';
export * as pubsubSchemaIamPolicy from './pubsub-schema-iam-policy';
export * as pubsubSubscription from './pubsub-subscription';
export * as pubsubSubscriptionIamBinding from './pubsub-subscription-iam-binding';
export * as pubsubSubscriptionIamMember from './pubsub-subscription-iam-member';
export * as pubsubSubscriptionIamPolicy from './pubsub-subscription-iam-policy';
export * as pubsubTopic from './pubsub-topic';
export * as pubsubTopicIamBinding from './pubsub-topic-iam-binding';
export * as pubsubTopicIamMember from './pubsub-topic-iam-member';
export * as pubsubTopicIamPolicy from './pubsub-topic-iam-policy';
export * as recaptchaEnterpriseKey from './recaptcha-enterprise-key';
export * as redisCluster from './redis-cluster';
export * as redisInstance from './redis-instance';
export * as resourceManagerLien from './resource-manager-lien';
export * as sccEventThreatDetectionCustomModule from './scc-event-threat-detection-custom-module';
export * as sccFolderCustomModule from './scc-folder-custom-module';
export * as sccManagementFolderSecurityHealthAnalyticsCustomModule from './scc-management-folder-security-health-analytics-custom-module';
export * as sccManagementOrganizationEventThreatDetectionCustomModule from './scc-management-organization-event-threat-detection-custom-module';
export * as sccManagementOrganizationSecurityHealthAnalyticsCustomModule from './scc-management-organization-security-health-analytics-custom-module';
export * as sccManagementProjectSecurityHealthAnalyticsCustomModule from './scc-management-project-security-health-analytics-custom-module';
export * as sccMuteConfig from './scc-mute-config';
export * as sccNotificationConfig from './scc-notification-config';
export * as sccOrganizationCustomModule from './scc-organization-custom-module';
export * as sccProjectCustomModule from './scc-project-custom-module';
export * as sccSource from './scc-source';
export * as sccSourceIamBinding from './scc-source-iam-binding';
export * as sccSourceIamMember from './scc-source-iam-member';
export * as sccSourceIamPolicy from './scc-source-iam-policy';
export * as secretManagerSecret from './secret-manager-secret';
export * as secretManagerSecretIamBinding from './secret-manager-secret-iam-binding';
export * as secretManagerSecretIamMember from './secret-manager-secret-iam-member';
export * as secretManagerSecretIamPolicy from './secret-manager-secret-iam-policy';
export * as secretManagerSecretVersion from './secret-manager-secret-version';
export * as secureSourceManagerInstance from './secure-source-manager-instance';
export * as secureSourceManagerInstanceIamBinding from './secure-source-manager-instance-iam-binding';
export * as secureSourceManagerInstanceIamMember from './secure-source-manager-instance-iam-member';
export * as secureSourceManagerInstanceIamPolicy from './secure-source-manager-instance-iam-policy';
export * as securityposturePosture from './securityposture-posture';
export * as securityposturePostureDeployment from './securityposture-posture-deployment';
export * as serviceAccount from './service-account';
export * as serviceAccountIamBinding from './service-account-iam-binding';
export * as serviceAccountIamMember from './service-account-iam-member';
export * as serviceAccountIamPolicy from './service-account-iam-policy';
export * as serviceAccountKey from './service-account-key';
export * as serviceNetworkingConnection from './service-networking-connection';
export * as serviceNetworkingPeeredDnsDomain from './service-networking-peered-dns-domain';
export * as serviceNetworkingVpcServiceControls from './service-networking-vpc-service-controls';
export * as sourcerepoRepository from './sourcerepo-repository';
export * as sourcerepoRepositoryIamBinding from './sourcerepo-repository-iam-binding';
export * as sourcerepoRepositoryIamMember from './sourcerepo-repository-iam-member';
export * as sourcerepoRepositoryIamPolicy from './sourcerepo-repository-iam-policy';
export * as spannerDatabase from './spanner-database';
export * as spannerDatabaseIamBinding from './spanner-database-iam-binding';
export * as spannerDatabaseIamMember from './spanner-database-iam-member';
export * as spannerDatabaseIamPolicy from './spanner-database-iam-policy';
export * as spannerInstance from './spanner-instance';
export * as spannerInstanceConfig from './spanner-instance-config';
export * as spannerInstanceIamBinding from './spanner-instance-iam-binding';
export * as spannerInstanceIamMember from './spanner-instance-iam-member';
export * as spannerInstanceIamPolicy from './spanner-instance-iam-policy';
export * as sqlDatabase from './sql-database';
export * as sqlDatabaseInstance from './sql-database-instance';
export * as sqlSourceRepresentationInstance from './sql-source-representation-instance';
export * as sqlSslCert from './sql-ssl-cert';
export * as sqlUser from './sql-user';
export * as storageBucket from './storage-bucket';
export * as storageBucketAccessControl from './storage-bucket-access-control';
export * as storageBucketAcl from './storage-bucket-acl';
export * as storageBucketIamBinding from './storage-bucket-iam-binding';
export * as storageBucketIamMember from './storage-bucket-iam-member';
export * as storageBucketIamPolicy from './storage-bucket-iam-policy';
export * as storageBucketObject from './storage-bucket-object';
export * as storageDefaultObjectAccessControl from './storage-default-object-access-control';
export * as storageDefaultObjectAcl from './storage-default-object-acl';
export * as storageHmacKey from './storage-hmac-key';
export * as storageInsightsReportConfig from './storage-insights-report-config';
export * as storageManagedFolder from './storage-managed-folder';
export * as storageManagedFolderIamBinding from './storage-managed-folder-iam-binding';
export * as storageManagedFolderIamMember from './storage-managed-folder-iam-member';
export * as storageManagedFolderIamPolicy from './storage-managed-folder-iam-policy';
export * as storageNotification from './storage-notification';
export * as storageObjectAccessControl from './storage-object-access-control';
export * as storageObjectAcl from './storage-object-acl';
export * as storageTransferAgentPool from './storage-transfer-agent-pool';
export * as storageTransferJob from './storage-transfer-job';
export * as tagsLocationTagBinding from './tags-location-tag-binding';
export * as tagsTagBinding from './tags-tag-binding';
export * as tagsTagKey from './tags-tag-key';
export * as tagsTagKeyIamBinding from './tags-tag-key-iam-binding';
export * as tagsTagKeyIamMember from './tags-tag-key-iam-member';
export * as tagsTagKeyIamPolicy from './tags-tag-key-iam-policy';
export * as tagsTagValue from './tags-tag-value';
export * as tagsTagValueIamBinding from './tags-tag-value-iam-binding';
export * as tagsTagValueIamMember from './tags-tag-value-iam-member';
export * as tagsTagValueIamPolicy from './tags-tag-value-iam-policy';
export * as tpuNode from './tpu-node';
export * as vertexAiDataset from './vertex-ai-dataset';
export * as vertexAiDeploymentResourcePool from './vertex-ai-deployment-resource-pool';
export * as vertexAiEndpoint from './vertex-ai-endpoint';
export * as vertexAiFeatureGroup from './vertex-ai-feature-group';
export * as vertexAiFeatureGroupFeature from './vertex-ai-feature-group-feature';
export * as vertexAiFeatureOnlineStore from './vertex-ai-feature-online-store';
export * as vertexAiFeatureOnlineStoreFeatureview from './vertex-ai-feature-online-store-featureview';
export * as vertexAiFeaturestore from './vertex-ai-featurestore';
export * as vertexAiFeaturestoreEntitytype from './vertex-ai-featurestore-entitytype';
export * as vertexAiFeaturestoreEntitytypeFeature from './vertex-ai-featurestore-entitytype-feature';
export * as vertexAiIndex from './vertex-ai-index';
export * as vertexAiIndexEndpoint from './vertex-ai-index-endpoint';
export * as vertexAiTensorboard from './vertex-ai-tensorboard';
export * as vmwareengineCluster from './vmwareengine-cluster';
export * as vmwareengineExternalAccessRule from './vmwareengine-external-access-rule';
export * as vmwareengineExternalAddress from './vmwareengine-external-address';
export * as vmwareengineNetwork from './vmwareengine-network';
export * as vmwareengineNetworkPeering from './vmwareengine-network-peering';
export * as vmwareengineNetworkPolicy from './vmwareengine-network-policy';
export * as vmwareenginePrivateCloud from './vmwareengine-private-cloud';
export * as vmwareengineSubnet from './vmwareengine-subnet';
export * as vpcAccessConnector from './vpc-access-connector';
export * as workbenchInstance from './workbench-instance';
export * as workbenchInstanceIamBinding from './workbench-instance-iam-binding';
export * as workbenchInstanceIamMember from './workbench-instance-iam-member';
export * as workbenchInstanceIamPolicy from './workbench-instance-iam-policy';
export * as workflowsWorkflow from './workflows-workflow';
export * as dataGoogleAccessApprovalFolderServiceAccount from './data-google-access-approval-folder-service-account';
export * as dataGoogleAccessApprovalOrganizationServiceAccount from './data-google-access-approval-organization-service-account';
export * as dataGoogleAccessApprovalProjectServiceAccount from './data-google-access-approval-project-service-account';
export * as dataGoogleAccessContextManagerAccessPolicyIamPolicy from './data-google-access-context-manager-access-policy-iam-policy';
export * as dataGoogleActiveFolder from './data-google-active-folder';
export * as dataGoogleAlloydbLocations from './data-google-alloydb-locations';
export * as dataGoogleAlloydbSupportedDatabaseFlags from './data-google-alloydb-supported-database-flags';
export * as dataGoogleApigeeEnvironmentIamPolicy from './data-google-apigee-environment-iam-policy';
export * as dataGoogleAppEngineDefaultServiceAccount from './data-google-app-engine-default-service-account';
export * as dataGoogleApphubApplication from './data-google-apphub-application';
export * as dataGoogleApphubDiscoveredService from './data-google-apphub-discovered-service';
export * as dataGoogleApphubDiscoveredWorkload from './data-google-apphub-discovered-workload';
export * as dataGoogleArtifactRegistryDockerImage from './data-google-artifact-registry-docker-image';
export * as dataGoogleArtifactRegistryRepository from './data-google-artifact-registry-repository';
export * as dataGoogleArtifactRegistryRepositoryIamPolicy from './data-google-artifact-registry-repository-iam-policy';
export * as dataGoogleBeyondcorpAppConnection from './data-google-beyondcorp-app-connection';
export * as dataGoogleBeyondcorpAppConnector from './data-google-beyondcorp-app-connector';
export * as dataGoogleBeyondcorpAppGateway from './data-google-beyondcorp-app-gateway';
export * as dataGoogleBigqueryAnalyticsHubDataExchangeIamPolicy from './data-google-bigquery-analytics-hub-data-exchange-iam-policy';
export * as dataGoogleBigqueryAnalyticsHubListingIamPolicy from './data-google-bigquery-analytics-hub-listing-iam-policy';
export * as dataGoogleBigqueryConnectionIamPolicy from './data-google-bigquery-connection-iam-policy';
export * as dataGoogleBigqueryDatapolicyDataPolicyIamPolicy from './data-google-bigquery-datapolicy-data-policy-iam-policy';
export * as dataGoogleBigqueryDataset from './data-google-bigquery-dataset';
export * as dataGoogleBigqueryDatasetIamPolicy from './data-google-bigquery-dataset-iam-policy';
export * as dataGoogleBigqueryDefaultServiceAccount from './data-google-bigquery-default-service-account';
export * as dataGoogleBigqueryTableIamPolicy from './data-google-bigquery-table-iam-policy';
export * as dataGoogleBigtableInstanceIamPolicy from './data-google-bigtable-instance-iam-policy';
export * as dataGoogleBigtableTableIamPolicy from './data-google-bigtable-table-iam-policy';
export * as dataGoogleBillingAccount from './data-google-billing-account';
export * as dataGoogleBillingAccountIamPolicy from './data-google-billing-account-iam-policy';
export * as dataGoogleBinaryAuthorizationAttestorIamPolicy from './data-google-binary-authorization-attestor-iam-policy';
export * as dataGoogleCertificateManagerCertificateMap from './data-google-certificate-manager-certificate-map';
export * as dataGoogleClientConfig from './data-google-client-config';
export * as dataGoogleClientOpenidUserinfo from './data-google-client-openid-userinfo';
export * as dataGoogleCloudAssetSearchAllResources from './data-google-cloud-asset-search-all-resources';
export * as dataGoogleCloudIdentityGroupLookup from './data-google-cloud-identity-group-lookup';
export * as dataGoogleCloudIdentityGroupMemberships from './data-google-cloud-identity-group-memberships';
export * as dataGoogleCloudIdentityGroups from './data-google-cloud-identity-groups';
export * as dataGoogleCloudQuotasQuotaInfo from './data-google-cloud-quotas-quota-info';
export * as dataGoogleCloudQuotasQuotaInfos from './data-google-cloud-quotas-quota-infos';
export * as dataGoogleCloudRunLocations from './data-google-cloud-run-locations';
export * as dataGoogleCloudRunService from './data-google-cloud-run-service';
export * as dataGoogleCloudRunServiceIamPolicy from './data-google-cloud-run-service-iam-policy';
export * as dataGoogleCloudRunV2Job from './data-google-cloud-run-v2-job';
export * as dataGoogleCloudRunV2JobIamPolicy from './data-google-cloud-run-v2-job-iam-policy';
export * as dataGoogleCloudRunV2Service from './data-google-cloud-run-v2-service';
export * as dataGoogleCloudRunV2ServiceIamPolicy from './data-google-cloud-run-v2-service-iam-policy';
export * as dataGoogleCloudTasksQueueIamPolicy from './data-google-cloud-tasks-queue-iam-policy';
export * as dataGoogleCloudbuildTrigger from './data-google-cloudbuild-trigger';
export * as dataGoogleCloudbuildv2ConnectionIamPolicy from './data-google-cloudbuildv2-connection-iam-policy';
export * as dataGoogleClouddeployCustomTargetTypeIamPolicy from './data-google-clouddeploy-custom-target-type-iam-policy';
export * as dataGoogleClouddeployDeliveryPipelineIamPolicy from './data-google-clouddeploy-delivery-pipeline-iam-policy';
export * as dataGoogleClouddeployTargetIamPolicy from './data-google-clouddeploy-target-iam-policy';
export * as dataGoogleCloudfunctions2Function from './data-google-cloudfunctions2-function';
export * as dataGoogleCloudfunctions2FunctionIamPolicy from './data-google-cloudfunctions2-function-iam-policy';
export * as dataGoogleCloudfunctionsFunction from './data-google-cloudfunctions-function';
export * as dataGoogleCloudfunctionsFunctionIamPolicy from './data-google-cloudfunctions-function-iam-policy';
export * as dataGoogleComposerEnvironment from './data-google-composer-environment';
export * as dataGoogleComposerImageVersions from './data-google-composer-image-versions';
export * as dataGoogleComputeAddress from './data-google-compute-address';
export * as dataGoogleComputeAddresses from './data-google-compute-addresses';
export * as dataGoogleComputeBackendBucket from './data-google-compute-backend-bucket';
export * as dataGoogleComputeBackendService from './data-google-compute-backend-service';
export * as dataGoogleComputeDefaultServiceAccount from './data-google-compute-default-service-account';
export * as dataGoogleComputeDisk from './data-google-compute-disk';
export * as dataGoogleComputeDiskIamPolicy from './data-google-compute-disk-iam-policy';
export * as dataGoogleComputeForwardingRule from './data-google-compute-forwarding-rule';
export * as dataGoogleComputeForwardingRules from './data-google-compute-forwarding-rules';
export * as dataGoogleComputeGlobalAddress from './data-google-compute-global-address';
export * as dataGoogleComputeGlobalForwardingRule from './data-google-compute-global-forwarding-rule';
export * as dataGoogleComputeHaVpnGateway from './data-google-compute-ha-vpn-gateway';
export * as dataGoogleComputeHealthCheck from './data-google-compute-health-check';
export * as dataGoogleComputeImage from './data-google-compute-image';
export * as dataGoogleComputeImageIamPolicy from './data-google-compute-image-iam-policy';
export * as dataGoogleComputeInstance from './data-google-compute-instance';
export * as dataGoogleComputeInstanceGroup from './data-google-compute-instance-group';
export * as dataGoogleComputeInstanceGroupManager from './data-google-compute-instance-group-manager';
export * as dataGoogleComputeInstanceIamPolicy from './data-google-compute-instance-iam-policy';
export * as dataGoogleComputeInstanceSerialPort from './data-google-compute-instance-serial-port';
export * as dataGoogleComputeInstanceTemplate from './data-google-compute-instance-template';
export * as dataGoogleComputeLbIpRanges from './data-google-compute-lb-ip-ranges';
export * as dataGoogleComputeMachineTypes from './data-google-compute-machine-types';
export * as dataGoogleComputeNetwork from './data-google-compute-network';
export * as dataGoogleComputeNetworkEndpointGroup from './data-google-compute-network-endpoint-group';
export * as dataGoogleComputeNetworkPeering from './data-google-compute-network-peering';
export * as dataGoogleComputeNetworks from './data-google-compute-networks';
export * as dataGoogleComputeNodeTypes from './data-google-compute-node-types';
export * as dataGoogleComputeRegionDisk from './data-google-compute-region-disk';
export * as dataGoogleComputeRegionDiskIamPolicy from './data-google-compute-region-disk-iam-policy';
export * as dataGoogleComputeRegionInstanceGroup from './data-google-compute-region-instance-group';
export * as dataGoogleComputeRegionInstanceTemplate from './data-google-compute-region-instance-template';
export * as dataGoogleComputeRegionNetworkEndpointGroup from './data-google-compute-region-network-endpoint-group';
export * as dataGoogleComputeRegionSslCertificate from './data-google-compute-region-ssl-certificate';
export * as dataGoogleComputeRegions from './data-google-compute-regions';
export * as dataGoogleComputeReservation from './data-google-compute-reservation';
export * as dataGoogleComputeResourcePolicy from './data-google-compute-resource-policy';
export * as dataGoogleComputeRouter from './data-google-compute-router';
export * as dataGoogleComputeRouterNat from './data-google-compute-router-nat';
export * as dataGoogleComputeRouterStatus from './data-google-compute-router-status';
export * as dataGoogleComputeSecurityPolicy from './data-google-compute-security-policy';
export * as dataGoogleComputeSnapshot from './data-google-compute-snapshot';
export * as dataGoogleComputeSnapshotIamPolicy from './data-google-compute-snapshot-iam-policy';
export * as dataGoogleComputeSslCertificate from './data-google-compute-ssl-certificate';
export * as dataGoogleComputeSslPolicy from './data-google-compute-ssl-policy';
export * as dataGoogleComputeSubnetwork from './data-google-compute-subnetwork';
export * as dataGoogleComputeSubnetworkIamPolicy from './data-google-compute-subnetwork-iam-policy';
export * as dataGoogleComputeSubnetworks from './data-google-compute-subnetworks';
export * as dataGoogleComputeVpnGateway from './data-google-compute-vpn-gateway';
export * as dataGoogleComputeZones from './data-google-compute-zones';
export * as dataGoogleContainerAnalysisNoteIamPolicy from './data-google-container-analysis-note-iam-policy';
export * as dataGoogleContainerAttachedInstallManifest from './data-google-container-attached-install-manifest';
export * as dataGoogleContainerAttachedVersions from './data-google-container-attached-versions';
export * as dataGoogleContainerAwsVersions from './data-google-container-aws-versions';
export * as dataGoogleContainerAzureVersions from './data-google-container-azure-versions';
export * as dataGoogleContainerCluster from './data-google-container-cluster';
export * as dataGoogleContainerEngineVersions from './data-google-container-engine-versions';
export * as dataGoogleContainerRegistryImage from './data-google-container-registry-image';
export * as dataGoogleContainerRegistryRepository from './data-google-container-registry-repository';
export * as dataGoogleDataCatalogEntryGroupIamPolicy from './data-google-data-catalog-entry-group-iam-policy';
export * as dataGoogleDataCatalogPolicyTagIamPolicy from './data-google-data-catalog-policy-tag-iam-policy';
export * as dataGoogleDataCatalogTagTemplateIamPolicy from './data-google-data-catalog-tag-template-iam-policy';
export * as dataGoogleDataCatalogTaxonomyIamPolicy from './data-google-data-catalog-taxonomy-iam-policy';
export * as dataGoogleDataFusionInstanceIamPolicy from './data-google-data-fusion-instance-iam-policy';
export * as dataGoogleDataplexAspectTypeIamPolicy from './data-google-dataplex-aspect-type-iam-policy';
export * as dataGoogleDataplexAssetIamPolicy from './data-google-dataplex-asset-iam-policy';
export * as dataGoogleDataplexDatascanIamPolicy from './data-google-dataplex-datascan-iam-policy';
export * as dataGoogleDataplexEntryGroupIamPolicy from './data-google-dataplex-entry-group-iam-policy';
export * as dataGoogleDataplexEntryTypeIamPolicy from './data-google-dataplex-entry-type-iam-policy';
export * as dataGoogleDataplexLakeIamPolicy from './data-google-dataplex-lake-iam-policy';
export * as dataGoogleDataplexTaskIamPolicy from './data-google-dataplex-task-iam-policy';
export * as dataGoogleDataplexZoneIamPolicy from './data-google-dataplex-zone-iam-policy';
export * as dataGoogleDataprocAutoscalingPolicyIamPolicy from './data-google-dataproc-autoscaling-policy-iam-policy';
export * as dataGoogleDataprocClusterIamPolicy from './data-google-dataproc-cluster-iam-policy';
export * as dataGoogleDataprocJobIamPolicy from './data-google-dataproc-job-iam-policy';
export * as dataGoogleDataprocMetastoreFederationIamPolicy from './data-google-dataproc-metastore-federation-iam-policy';
export * as dataGoogleDataprocMetastoreService from './data-google-dataproc-metastore-service';
export * as dataGoogleDataprocMetastoreServiceIamPolicy from './data-google-dataproc-metastore-service-iam-policy';
export * as dataGoogleDatastreamStaticIps from './data-google-datastream-static-ips';
export * as dataGoogleDnsKeys from './data-google-dns-keys';
export * as dataGoogleDnsManagedZone from './data-google-dns-managed-zone';
export * as dataGoogleDnsManagedZoneIamPolicy from './data-google-dns-managed-zone-iam-policy';
export * as dataGoogleDnsManagedZones from './data-google-dns-managed-zones';
export * as dataGoogleDnsRecordSet from './data-google-dns-record-set';
export * as dataGoogleEndpointsServiceConsumersIamPolicy from './data-google-endpoints-service-consumers-iam-policy';
export * as dataGoogleEndpointsServiceIamPolicy from './data-google-endpoints-service-iam-policy';
export * as dataGoogleFilestoreInstance from './data-google-filestore-instance';
export * as dataGoogleFolder from './data-google-folder';
export * as dataGoogleFolderIamPolicy from './data-google-folder-iam-policy';
export * as dataGoogleFolderOrganizationPolicy from './data-google-folder-organization-policy';
export * as dataGoogleFolders from './data-google-folders';
export * as dataGoogleGkeBackupBackupPlanIamPolicy from './data-google-gke-backup-backup-plan-iam-policy';
export * as dataGoogleGkeBackupRestorePlanIamPolicy from './data-google-gke-backup-restore-plan-iam-policy';
export * as dataGoogleGkeHubFeatureIamPolicy from './data-google-gke-hub-feature-iam-policy';
export * as dataGoogleGkeHubMembershipIamPolicy from './data-google-gke-hub-membership-iam-policy';
export * as dataGoogleGkeHubScopeIamPolicy from './data-google-gke-hub-scope-iam-policy';
export * as dataGoogleHealthcareConsentStoreIamPolicy from './data-google-healthcare-consent-store-iam-policy';
export * as dataGoogleHealthcareDatasetIamPolicy from './data-google-healthcare-dataset-iam-policy';
export * as dataGoogleHealthcareDicomStoreIamPolicy from './data-google-healthcare-dicom-store-iam-policy';
export * as dataGoogleHealthcareFhirStoreIamPolicy from './data-google-healthcare-fhir-store-iam-policy';
export * as dataGoogleHealthcareHl7V2StoreIamPolicy from './data-google-healthcare-hl7-v2-store-iam-policy';
export * as dataGoogleIamPolicy from './data-google-iam-policy';
export * as dataGoogleIamRole from './data-google-iam-role';
export * as dataGoogleIamTestablePermissions from './data-google-iam-testable-permissions';
export * as dataGoogleIapAppEngineServiceIamPolicy from './data-google-iap-app-engine-service-iam-policy';
export * as dataGoogleIapAppEngineVersionIamPolicy from './data-google-iap-app-engine-version-iam-policy';
export * as dataGoogleIapClient from './data-google-iap-client';
export * as dataGoogleIapTunnelDestGroupIamPolicy from './data-google-iap-tunnel-dest-group-iam-policy';
export * as dataGoogleIapTunnelIamPolicy from './data-google-iap-tunnel-iam-policy';
export * as dataGoogleIapTunnelInstanceIamPolicy from './data-google-iap-tunnel-instance-iam-policy';
export * as dataGoogleIapWebBackendServiceIamPolicy from './data-google-iap-web-backend-service-iam-policy';
export * as dataGoogleIapWebIamPolicy from './data-google-iap-web-iam-policy';
export * as dataGoogleIapWebRegionBackendServiceIamPolicy from './data-google-iap-web-region-backend-service-iam-policy';
export * as dataGoogleIapWebTypeAppEngineIamPolicy from './data-google-iap-web-type-app-engine-iam-policy';
export * as dataGoogleIapWebTypeComputeIamPolicy from './data-google-iap-web-type-compute-iam-policy';
export * as dataGoogleKmsCryptoKey from './data-google-kms-crypto-key';
export * as dataGoogleKmsCryptoKeyIamPolicy from './data-google-kms-crypto-key-iam-policy';
export * as dataGoogleKmsCryptoKeyVersion from './data-google-kms-crypto-key-version';
export * as dataGoogleKmsKeyRing from './data-google-kms-key-ring';
export * as dataGoogleKmsKeyRingIamPolicy from './data-google-kms-key-ring-iam-policy';
export * as dataGoogleKmsSecret from './data-google-kms-secret';
export * as dataGoogleKmsSecretCiphertext from './data-google-kms-secret-ciphertext';
export * as dataGoogleLoggingFolderSettings from './data-google-logging-folder-settings';
export * as dataGoogleLoggingOrganizationSettings from './data-google-logging-organization-settings';
export * as dataGoogleLoggingProjectCmekSettings from './data-google-logging-project-cmek-settings';
export * as dataGoogleLoggingProjectSettings from './data-google-logging-project-settings';
export * as dataGoogleLoggingSink from './data-google-logging-sink';
export * as dataGoogleMonitoringAppEngineService from './data-google-monitoring-app-engine-service';
export * as dataGoogleMonitoringClusterIstioService from './data-google-monitoring-cluster-istio-service';
export * as dataGoogleMonitoringIstioCanonicalService from './data-google-monitoring-istio-canonical-service';
export * as dataGoogleMonitoringMeshIstioService from './data-google-monitoring-mesh-istio-service';
export * as dataGoogleMonitoringNotificationChannel from './data-google-monitoring-notification-channel';
export * as dataGoogleMonitoringUptimeCheckIps from './data-google-monitoring-uptime-check-ips';
export * as dataGoogleNetblockIpRanges from './data-google-netblock-ip-ranges';
export * as dataGoogleNetworkSecurityAddressGroupIamPolicy from './data-google-network-security-address-group-iam-policy';
export * as dataGoogleNotebooksInstanceIamPolicy from './data-google-notebooks-instance-iam-policy';
export * as dataGoogleNotebooksRuntimeIamPolicy from './data-google-notebooks-runtime-iam-policy';
export * as dataGoogleOrganization from './data-google-organization';
export * as dataGoogleOrganizationIamPolicy from './data-google-organization-iam-policy';
export * as dataGooglePrivatecaCaPoolIamPolicy from './data-google-privateca-ca-pool-iam-policy';
export * as dataGooglePrivatecaCertificateAuthority from './data-google-privateca-certificate-authority';
export * as dataGooglePrivatecaCertificateTemplateIamPolicy from './data-google-privateca-certificate-template-iam-policy';
export * as dataGoogleProject from './data-google-project';
export * as dataGoogleProjectIamPolicy from './data-google-project-iam-policy';
export * as dataGoogleProjectOrganizationPolicy from './data-google-project-organization-policy';
export * as dataGoogleProjectService from './data-google-project-service';
export * as dataGoogleProjects from './data-google-projects';
export * as dataGooglePubsubSchemaIamPolicy from './data-google-pubsub-schema-iam-policy';
export * as dataGooglePubsubSubscription from './data-google-pubsub-subscription';
export * as dataGooglePubsubSubscriptionIamPolicy from './data-google-pubsub-subscription-iam-policy';
export * as dataGooglePubsubTopic from './data-google-pubsub-topic';
export * as dataGooglePubsubTopicIamPolicy from './data-google-pubsub-topic-iam-policy';
export * as dataGoogleRedisInstance from './data-google-redis-instance';
export * as dataGoogleSccSourceIamPolicy from './data-google-scc-source-iam-policy';
export * as dataGoogleSecretManagerSecret from './data-google-secret-manager-secret';
export * as dataGoogleSecretManagerSecretIamPolicy from './data-google-secret-manager-secret-iam-policy';
export * as dataGoogleSecretManagerSecretVersion from './data-google-secret-manager-secret-version';
export * as dataGoogleSecretManagerSecretVersionAccess from './data-google-secret-manager-secret-version-access';
export * as dataGoogleSecretManagerSecrets from './data-google-secret-manager-secrets';
export * as dataGoogleSecureSourceManagerInstanceIamPolicy from './data-google-secure-source-manager-instance-iam-policy';
export * as dataGoogleServiceAccount from './data-google-service-account';
export * as dataGoogleServiceAccountAccessToken from './data-google-service-account-access-token';
export * as dataGoogleServiceAccountIamPolicy from './data-google-service-account-iam-policy';
export * as dataGoogleServiceAccountIdToken from './data-google-service-account-id-token';
export * as dataGoogleServiceAccountJwt from './data-google-service-account-jwt';
export * as dataGoogleServiceAccountKey from './data-google-service-account-key';
export * as dataGoogleServiceNetworkingPeeredDnsDomain from './data-google-service-networking-peered-dns-domain';
export * as dataGoogleSourcerepoRepository from './data-google-sourcerepo-repository';
export * as dataGoogleSourcerepoRepositoryIamPolicy from './data-google-sourcerepo-repository-iam-policy';
export * as dataGoogleSpannerDatabaseIamPolicy from './data-google-spanner-database-iam-policy';
export * as dataGoogleSpannerInstance from './data-google-spanner-instance';
export * as dataGoogleSpannerInstanceIamPolicy from './data-google-spanner-instance-iam-policy';
export * as dataGoogleSqlBackupRun from './data-google-sql-backup-run';
export * as dataGoogleSqlCaCerts from './data-google-sql-ca-certs';
export * as dataGoogleSqlDatabase from './data-google-sql-database';
export * as dataGoogleSqlDatabaseInstance from './data-google-sql-database-instance';
export * as dataGoogleSqlDatabaseInstanceLatestRecoveryTime from './data-google-sql-database-instance-latest-recovery-time';
export * as dataGoogleSqlDatabaseInstances from './data-google-sql-database-instances';
export * as dataGoogleSqlDatabases from './data-google-sql-databases';
export * as dataGoogleSqlTiers from './data-google-sql-tiers';
export * as dataGoogleStorageBucket from './data-google-storage-bucket';
export * as dataGoogleStorageBucketIamPolicy from './data-google-storage-bucket-iam-policy';
export * as dataGoogleStorageBucketObject from './data-google-storage-bucket-object';
export * as dataGoogleStorageBucketObjectContent from './data-google-storage-bucket-object-content';
export * as dataGoogleStorageBucketObjects from './data-google-storage-bucket-objects';
export * as dataGoogleStorageBuckets from './data-google-storage-buckets';
export * as dataGoogleStorageManagedFolderIamPolicy from './data-google-storage-managed-folder-iam-policy';
export * as dataGoogleStorageObjectSignedUrl from './data-google-storage-object-signed-url';
export * as dataGoogleStorageProjectServiceAccount from './data-google-storage-project-service-account';
export * as dataGoogleStorageTransferProjectServiceAccount from './data-google-storage-transfer-project-service-account';
export * as dataGoogleTagsTagKey from './data-google-tags-tag-key';
export * as dataGoogleTagsTagKeyIamPolicy from './data-google-tags-tag-key-iam-policy';
export * as dataGoogleTagsTagKeys from './data-google-tags-tag-keys';
export * as dataGoogleTagsTagValue from './data-google-tags-tag-value';
export * as dataGoogleTagsTagValueIamPolicy from './data-google-tags-tag-value-iam-policy';
export * as dataGoogleTagsTagValues from './data-google-tags-tag-values';
export * as dataGoogleTpuTensorflowVersions from './data-google-tpu-tensorflow-versions';
export * as dataGoogleVertexAiIndex from './data-google-vertex-ai-index';
export * as dataGoogleVmwareengineCluster from './data-google-vmwareengine-cluster';
export * as dataGoogleVmwareengineExternalAccessRule from './data-google-vmwareengine-external-access-rule';
export * as dataGoogleVmwareengineExternalAddress from './data-google-vmwareengine-external-address';
export * as dataGoogleVmwareengineNetwork from './data-google-vmwareengine-network';
export * as dataGoogleVmwareengineNetworkPeering from './data-google-vmwareengine-network-peering';
export * as dataGoogleVmwareengineNetworkPolicy from './data-google-vmwareengine-network-policy';
export * as dataGoogleVmwareengineNsxCredentials from './data-google-vmwareengine-nsx-credentials';
export * as dataGoogleVmwareenginePrivateCloud from './data-google-vmwareengine-private-cloud';
export * as dataGoogleVmwareengineSubnet from './data-google-vmwareengine-subnet';
export * as dataGoogleVmwareengineVcenterCredentials from './data-google-vmwareengine-vcenter-credentials';
export * as dataGoogleVpcAccessConnector from './data-google-vpc-access-connector';
export * as dataGoogleWorkbenchInstanceIamPolicy from './data-google-workbench-instance-iam-policy';
export * as provider from './provider';
